/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#include "Slice.h"

Slice::Slice() {
    in_use=0;
	active=0;
	updated=true;
	oldIntMode=-1;
}


void Slice::updateStatus(String msg) {
	
	//Serial.println(msg);
	updated=true;
	int oldi=0;
	int i=msg.indexOf(' ',oldi);
	while (i>0) {
		setValue(msg.substring(oldi,i));
		oldi=i+1;
		i=msg.indexOf(' ',oldi+1);
	}	
	//get the last element
	i=msg.indexOf('\n',oldi);
	setValue(msg.substring(oldi,i));
	/*
	Serial.println(in_use);
	Serial.println(RF_frequency);
	Serial.println(rit_on);
	Serial.println(rit_freq);
	Serial.println(xit_on); 
	Serial.println(xit_freq);
	Serial.println(rxant);
	Serial.println(mode);
	Serial.println(wide);
	Serial.println(filter_lo);
	Serial.println(filter_hi);
	Serial.println(step);
	Serial.println(step_list);
	Serial.println(agc_mode);
	Serial.println(agc_threshold);
	Serial.println(agc_off_level);
	Serial.println(pan);
	Serial.println(txant);
	Serial.println(loopa);
	Serial.println(loopb);
	Serial.println(qsk);
	Serial.println(dax);
	Serial.println(dax_clients);
	Serial.println(lock);
	Serial.println(tx); 
	Serial.println(dax_tx); 
	Serial.println(active); 
	Serial.println(audio_gain);
	Serial.println(audio_pan);
	Serial.println(audio_mute);
	Serial.println(record);
	Serial.println(play); 
	Serial.println(record_time);
	Serial.println(anf);
	Serial.println(anf_level); 
	Serial.println(nr);
	Serial.println(nr_level);
	Serial.println(nb);
	Serial.println(nb_level);
	Serial.println(apf); 
	Serial.println(apf_level);
	Serial.println(diversity);
	Serial.println(diversity_parent);
	Serial.println(diversity_child);
	Serial.println(diversity_index);
	Serial.println(ant_list);
	*/

}

void Slice::setValue(String msg){
	int i=msg.indexOf('=');
	if (i>0) {
	    String var=msg.substring(0,i);
		//Serial.println(var);
		
		if (var.equals("in_use")) { in_use=msg.substring(i+1).toInt(); return; }
		if (var.equals("RF_frequency")) { RF_frequency=msg.substring(i+1).toFloat()*1000000; return; }
		if (var.equals("rit_on")) { rit_on=msg.substring(i+1).toInt(); return; }
		if (var.equals("rit_freq")) { rit_freq=msg.substring(i+1).toInt(); return; }
		if (var.equals("xit_on")) { xit_on=msg.substring(i+1).toInt(); return; } 
		if (var.equals("xit_freq")) { xit_freq=msg.substring(i+1).toInt(); return; }
		if (var.equals("rxant")) { rxant=msg.substring(i+1); return; }
		if (var.equals("mode")) { 
			mode=msg.substring(i+1); 
			setIntMode(mode);
			return; 
		}
		if (var.equals("wide")) { wide=msg.substring(i+1).toInt(); return; }
		if (var.equals("filter_lo")) {
			filter_lo=msg.substring(i+1).toInt(); 
			calcShiftWidthValue();
			return; 
		}
		if (var.equals("filter_hi")) {
			filter_hi=msg.substring(i+1).toInt();
			calcShiftWidthValue();
			return; 
		}
		if (var.equals("step")) { step=msg.substring(i+1).toInt(); return; }
		if (var.equals("step_list")) { step_list=msg.substring(i+1); return; }
		if (var.equals("agc_mode")) { agc_mode=msg.substring(i+1); return; }
		if (var.equals("agc_threshold")) { agc_threshold=msg.substring(i+1).toInt(); return; }
		if (var.equals("agc_off_level")) { agc_off_level=msg.substring(i+1).toInt(); return; }
		if (var.equals("pan")) { pan=msg.substring(i+3).toInt(); return; }
		if (var.equals("txant")) { txant=msg.substring(i+1); return; }
		if (var.equals("loopa")) { loopa=msg.substring(i+1).toInt(); return; }
		if (var.equals("loopb")) { loopb=msg.substring(i+1).toInt(); return; }
		if (var.equals("qsk")) { qsk=msg.substring(i+1).toInt(); return; }
		if (var.equals("dax")) { dax=msg.substring(i+1).toInt(); return; }
		if (var.equals("dax_clients")) { dax_clients=msg.substring(i+1).toInt(); return; }
		if (var.equals("lock")) { lock=msg.substring(i+1).toInt(); return; }
		if (var.equals("tx")) { tx=msg.substring(i+1).toInt(); return; } 
		if (var.equals("dax_tx")) { dax_tx=msg.substring(i+1).toInt(); return; } 
		if (var.equals("active")) { active=msg.substring(i+1).toInt(); return; } 
		if (var.equals("audio_gain")) { audio_gain=msg.substring(i+1).toInt(); return; }
		if (var.equals("audio_pan")) { audio_pan=msg.substring(i+1).toInt(); return; }
		if (var.equals("audio_mute")) { audio_mute=msg.substring(i+1).toInt(); return; }
		if (var.equals("record")) { record=msg.substring(i+1).toInt(); return; }
		if (var.equals("play")) { play=msg.substring(i+1); return; } 
		if (var.equals("record_time")) { record_time=msg.substring(i+1).toInt()*10; return; }
		if (var.equals("anf")) { anf=msg.substring(i+1).toInt(); return; }
		if (var.equals("anf_level")) { anf_level=msg.substring(i+1).toInt(); return; } 
		if (var.equals("nr")) { nr=msg.substring(i+1).toInt(); return; }
		if (var.equals("nr_level")) { nr_level=msg.substring(i+1).toInt(); return; }
		if (var.equals("nb")) { nb=msg.substring(i+1).toInt(); return; }
		if (var.equals("nb_level")) { nb_level=msg.substring(i+1).toInt(); return; }
		if (var.equals("apf")) { apf=msg.substring(i+1).toInt(); return; } 
		if (var.equals("apf_level")) { apf_level=msg.substring(i+1).toInt(); return; }
		if (var.equals("diversity")) { diversity=msg.substring(i+1).toInt(); return; }
		if (var.equals("diversity_parent")) { diversity_parent=msg.substring(i+1).toInt(); return; }
		if (var.equals("diversity_child")) { diversity_child=msg.substring(i+1).toInt(); return; }
		if (var.equals("diversity_index")) { diversity_index=msg.substring(i+1).toInt(); return; }
		if (var.equals("ant_list")) { ant_list=msg.substring(i+1); return; }

	}
}

void Slice::updateObject(int objectId,int value){
    switch(objectId) {
	 	case SLICE_AUDIO_GAIN:
		     audio_gain=value;
	 		 break;
	 	case SLICE_AUDIO_PAN:
		     audio_pan=value;
	 		 break;
	 	case SLICE_AGC_THRESHOLD:
		     agc_threshold=value;
	 		 break;
		case SLICE_AGC_OFF_LEVEL:	 
		     agc_off_level=value;
	 		 break;
		case SLICE_NB_LEVEL:
		     nb_level=value;
	 		 break;
		case SLICE_NR_LEVEL:
		     nr_level=value;
	 		 break;
		case SLICE_APF_LEVEL:
		     apf_level=value;
	 		 break;
		case SLICE_ANF_LEVEL:
		     anf_level=value;
	 		 break;
		case SLICE_RIT_FREQ:
		     rit_freq=value;
	 		 break;
		case SLICE_XIT_FREQ:
		     xit_freq=value;
	 		 break;
			 
		default:
			 Serial.print("Slice::updateObject - Unhandled id:"); Serial.println(objectId);
	}
	updated=true;
}

void Slice::setFilterLow(int value) {
	if (filter_lo+value<filter_hi) {
    	filter_lo+=value;
		calcShiftWidthValue();	
	}
}
 
void Slice::setFilterHigh(int value) {
		if (filter_hi+value>filter_lo) {
			filter_hi+=value;
			calcShiftWidthValue();
		}
}

void Slice::setFilterShift(int value) {
	filter_shift+=value;
	calcHighLowValues();
}


void Slice::setFilterWidth(int value) {
	filter_width+=value;
	calcHighLowValues();
}

void Slice::calcHighLowValues(){
     filter_lo=filter_shift-filter_width/2;
	 filter_hi=filter_shift+filter_width/2;    	
}

void Slice::calcShiftWidthValue(){
	filter_width=filter_hi-filter_lo;
	filter_shift=filter_lo+filter_width/2;	 
}
	
void Slice::setIntMode(String m) {
	//Serial.print("Mode:");Serial.println(mode);
	if (m.equals("LSB")) intMode=LSB;
	else if (m.equals("USB")) intMode=USB;
	else if (m.equals("AM")) intMode=AM;
	else if (m.equals("CW")) intMode=CW;
	else if (m.equals("DIGL")) intMode=DIGL;
	else if (m.equals("DIGU")) intMode=DIGU;
	else if (m.equals("SAM")) intMode=SAM_;
	else if (m.equals("FM")) intMode=FM;
	else if (m.equals("NFM")) intMode=NFM;
	else if (m.equals("DFM")) intMode=DFM;
}

int Slice::getBand() {

	int b=(int)RF_frequency/1000000;
	switch (b) {
		case 1:
			  b=160;
			  break;
		case 3:
				  b=80;
				  break;
		case 5:
				  b=60;
				  break;
		case 7:
				  b=40;
				  break;
		case 10:
				  b=30;
				  break;
		case 14:
				  b=20;
				  break;
		case 18:
				  b=17;
				  break;
		case 21:
				  b=15;
				  break;
		case 24:
				  b=12;
				  break;
		case 28:
				  b=10;
				  break;
		case 29:
				  b=10;
				  break;
		case 50:
				  b=6;
				  break;
		case 51:
				  b=6;
				  break;
		default:
				  b=-1;
	}
	return b;
}