/*
  Library support for FlexRadio 6000 Rigs
  Copyright (C)2015 Vincenzo Stefanazzi - IW7DMH. All right reserved

  This library is free software; you can redistribute it and/or
  modify it under the terms of the CC BY-NC-SA 3.0 license.
  https://creativecommons.org/licenses/by-nc-sa/3.0/
  
  The license applies to all part of the library including the 
  examples and tools supplied with the library.
*/
#ifndef Waterfall_h
#define Waterfall_h
#include "Arduino.h"

#define WATERFALL_BLACK_LEVEL 4000
#define WATERFALL_GRADIENT_INDEX 4001
#define WATERFALL_LINE_DURATION 4002
#define WATERFALL_COLOR_GAIN 4003

class Waterfall
{
  public:
    //properties
	int waterfall; // 0x42000000 
	int x_pixels; //=1170 
	int center; //=14.033201 
	int bandwidth; //=0.210171 
	int line_duration; //=100 
	int rfgain; //=0 
	String rxant; //=ANT1 
	int wide; //=0 
	int loopa; //=0 
	int loopb; //=0 
	int band; //=20 
	int daxiq; //=0 
	int daxiq_rate; //=0 
	int capacity; //=16 
	int available; //=14 
	int panadapter; //=40000000 
	int color_gain; //=31 
	int auto_black; //=1 
	int black_level; //=0 
	int gradient_index; //=0 
	int xvtr; //=

    //methods
    Waterfall();
	void updateStatus(String msg);
	void updateObject(int objectId,int value);  //Update specific waterfall object	
	boolean updated;
  private:
    //properties
	
    //methods	
	void setValue(String msg);
};
	
#endif